﻿using System.Windows;

using DevExpress.Xpf.Grid;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            BuildTree();

            this.treeListView.ExpandAllNodes();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 트리 구축하기 - BuildTree()

        /// <summary>
        /// 트리 구축하기
        /// </summary>
        private void BuildTree()
        {
            TreeListNode rootNode = GetRootTreeListNode(new ProjectObject() { Name = "Project : Stanton", Executor = "Nicholas Llams" });

            TreeListNode childNode = GetChildTreeListNode(rootNode, new StageObject() { Name = "Information Gathering", Executor = "Ankie Galva" });

            GetChildTreeListNode(childNode, new TaskObject() { Name = "Design", Executor = "Reardon Felton", State = "In progress" });
        }

        #endregion
        #region 루트 트리 리스트 노드 구하기 - GetRootTreeListNode(content)

        /// <summary>
        /// 루트 트리 리스트 노드 구하기
        /// </summary>
        /// <param name="content">컨텐트</param>
        /// <returns>루트 트리 리스트 노드</returns>
        private TreeListNode GetRootTreeListNode(object content)
        {
            TreeListNode node = new TreeListNode(content);

            treeListView.Nodes.Add(node);

            return node;
        }

        #endregion
        #region 자식 트리 리스트 노드 구하기 - GetChildTreeListNode(parentNode, content)

        /// <summary>
        /// 자식 트리 리스트 노드 구하기
        /// </summary>
        /// <param name="parentNode">부모 노드</param>
        /// <param name="content">컨텐츠</param>
        /// <returns>자식 노드</returns>
        private TreeListNode GetChildTreeListNode(TreeListNode parentNode, object content)
        {
            TreeListNode childeNode = new TreeListNode(content);

            parentNode.Nodes.Add(childeNode);

            return childeNode;
        }

        #endregion
    }
}
